Attribute VB_Name = "Common"
Option Explicit

Public NetDir As String
Public LogicDir As String
Public LocalAppDir As String

Public vrTagName As String, vrTagOpen As String, vrTagClose As String
Public vrMode As String, vrCsX As String, vrReplaceNode As String

Public BolServices As String
Public LgxServices As String

Public csRptEDIWinTxt As String, csRptFile As String

Private InitDone       As Boolean
Private Map1(0 To 63)  As Byte
Private Map2(0 To 127) As Byte

Dim commStr(10) As String, commInt(10) As Integer

Public Enum SaveToFileOptions
    Overwrite = 1
    Append = 2
    CreateUnique = 3
End Enum

Sub Initialize()
    LogicDir = CS32.ShipDir & "Logic"
    If KiEmpty(Dir(LogicDir, vbDirectory)) Then
        MkDir LogicDir
    End If
    LogicDir = LogicDir & "\"
    
    LocalAppDir = "C:\Logic"
    If KiEmpty(Dir(LocalAppDir, vbDirectory)) Then
        LocalAppDir = ProjectDir
    Else
        LocalAppDir = LocalAppDir & "\"
    End If
End Sub

Function GetCity(ByVal sCityState As String) As String
    sCityState = Alltrim(sCityState)
    GetCity = sCityState
    If SubStr(sCityState, Len(sCityState) - 2, 1) = " " Then
        GetCity = Alltrim(Left(sCityState, Len(sCityState) - 2))
    End If
End Function
Function GetState(ByVal sCityState As String) As String
    sCityState = Alltrim(sCityState)
    GetState = sCityState
    If SubStr(sCityState, Len(sCityState) - 2, 1) = " " Then
        GetState = Alltrim(Right(sCityState, 2))
    End If
End Function

Function SaveTextToFile(ByVal sText As String, ByVal sFileName As String, Optional ByVal sExtension As String = "txt", Optional sPath As String = "", Optional ByVal iSaveOption As SaveToFileOptions) As String
    SaveTextToFile = ""
    
    If KiEmpty(sPath) Then
        sPath = Common.LocalAppDir
    End If
    If Right(sPath, 1) <> "\" Then
        sPath = sPath & "\"
    End If

    If Not KiEmpty(sExtension) And Left(sExtension, 1) <> "." Then
        sExtension = "." & sExtension
    End If
    
    If (iSaveOption = CreateUnique) Then
        commStr(0) = ""
        Do While fExist(sPath & sFileName & commStr(0) & sExtension)
            commStr(0) = Alltrim(Str(Val(commStr(0)) - 1))
        Loop
        sFileName = sFileName & commStr(0)
    End If
    
    commInt(0) = FreeFile
    kiDebug sPath & sFileName & sExtension & ": " & commInt(0), Common.LocalAppDir & "Debug.log", "SaveTextToFile()"
    Open sPath & sFileName & sExtension For Output As commInt(0)
    Print #commInt(0), sText
    Close #commInt(0)
    
    SaveTextToFile = sFileName
End Function
Function GetUniqueFilename(ByVal sText As String, ByVal sFileName As String, Optional ByVal sExtension As String = "txt", Optional sPath As String = "") As String
    GetUniqueFilename = ""
    
    If KiEmpty(sPath) Then
        sPath = Common.LocalAppDir
    End If
    If Right(sPath, 1) <> "\" Then
        sPath = sPath & "\"
    End If

    If Not KiEmpty(sExtension) And Left(sExtension, 1) <> "." Then
        sExtension = "." & sExtension
    End If
    
    commStr(0) = ""
    Do While fExist(sPath & sFileName & commStr(0) & sExtension)
        commStr(0) = Alltrim(Str(Val(commStr(0)) - 1))
    Loop
    sFileName = sFileName & commStr(0)
    
    GetUniqueFilename = sFileName & sExtension
End Function

Public Function DbfZap(ByVal sDbfFile, Optional ByVal sCondition As String = "1=1") As Boolean
    DbfDelete sDbfFile, sCondition, False, 0
    DbfZap = DbfCleanup(sDbfFile)
End Function

Public Sub Sql_InsertParam(ByRef sSqlQuery As String, ByVal iFieldId As Integer, ByVal sFieldData As String)
    sFieldData = StrTran(sFieldData, "'", "''")
    sSqlQuery = StrTran(sSqlQuery, "<%" & iFieldId & ">", sFieldData)
End Sub



Function VarReplace(ByVal vrTextData As String, ByVal vrSource1 As KiDataView, Optional ByVal vrSource2 As KiDataView) As String
    Dim vrReplaceText As String
    Dim vrResultText As String

    If KiEmpty(vrTagName) Then vrTagName = "var"
    If KiEmpty(vrTagOpen) Then vrTagOpen = "<"
    If KiEmpty(vrTagClose) Then vrTagClose = ">"
    If KiEmpty(vrMode) Then vrMode = "cs"
    If vrMode = "cs" Then
        If Lower(vrCsX) <> "xx" Then vrCsX = "x"
    End If
    
    vrResultText = vrTextData
    Do While Not KiEmpty(vrResultText)
        Dim vrType As String, vrName As String, vrFormat As String, vrMask As String
        Dim vrStr1 As String, vrStr2 As String, vrStr3 As String, vrStr4 As String
        Dim vrInt1 As Integer, vrInt2 As Integer, vrInt3 As Integer, vrInt4 As Integer
    
        vrInt1 = At(vrTagOpen & vrTagName & " ", vrResultText)
        If vrInt1 = 0 Then Exit Do
        
        vrStr1 = SubStr(vrResultText, vrInt1)
        vrInt2 = At(vrTagClose, vrStr1)
        vrStr1 = Left(vrStr1, vrInt2)
        kiDebug vrStr1, ProjectDir & "Debug.log", "VarReplace"
    
        vrReplaceNode = vrStr1
        If vrTagOpen <> "<" Then
            vrReplaceNode = StrTran(vrReplaceNode, vrTagOpen, "<")
        End If
        If vrTagClose <> ">" Then
            vrReplaceNode = StrTran(vrReplaceNode, vrTagClose, ">")
        End If
    
        If vrReplaceNode <> vrStr1 Then
            vrResultText = StrTran(vrResultText, vrStr1, vrReplaceNode)
        End If
        kiDebug vrStr1, ProjectDir & "Debug.log", "VarReplace"
    
        vrReplaceText = ""
        vrStr1 = ""
        vrStr2 = ""
    

        vrType = Lower(XML.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@type"))
        vrName = XML.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@name")
        vrFormat = XML.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@format")
        vrMask = XML.ReadXPathFromText(vrReplaceNode, "/" + Alltrim(vrTagName) + "/@mask")
        If vrType = "csfield" Or vrType = "dbfield" Then
            vrReplaceText = Alltrim(vrSource1(vrName))
        ElseIf vrType = "custom" Then
            vrReplaceText = VarReplace_Custom(vrName, vrSource1)
        Else
        
        End If
        kiDebug vrReplaceText, ProjectDir & "Debug.log", "VarReplace"
        
        If Len(vrFormat) > 0 Then
            kiDebug "Format: " + vrFormat, ProjectDir & "Debug.log", "VarReplace"
            vrStr1 = Lower(Left(vrFormat, 1))
            If At(vrStr1, "bdfim") > 0 Then
                vrFormat = SubStr(vrFormat, 2)
            Else
                vrStr1 = "m"
            End If
            kiDebug "Format: Type=" + vrStr1 + "; Def=" + vrFormat, ProjectDir & "Debug.log", "VarReplace"
    
            vrStr2 = ""
            If vrStr1 = "f" Then 'Fixed-point
                vrStr2 = Str(Val(vrReplaceText), Val(SubToken(vrFormat, 1, ".")), Val(SubToken(vrFormat, 2, ".")))
                
            ElseIf vrStr1 = "d" Then 'Date
                vrStr2 = vrFormat
                
                vrStr2 = StrTran(vrStr2, "yyyy", Str(Year(CtoD(vrReplaceText))))
                vrStr2 = StrTran(vrStr2, "yy", Right(Str(Year(CtoD(vrReplaceText))), 2))
    
                vrStr2 = StrTran(vrStr2, "mmmm", Upper(Cmonth(CtoD(vrReplaceText))))
                vrStr2 = StrTran(vrStr2, "mmm", Left(Upper(Cmonth(CtoD(vrReplaceText))), 3))
                vrStr2 = StrTran(vrStr2, "mm", StrTran(Str(Month(CtoD(vrReplaceText)), 2), " ", "0"))
                vrStr2 = StrTran(vrStr2, "m", Str(Month(CtoD(vrReplaceText))))
    
                vrStr2 = StrTran(vrStr2, "dd", StrTran(Str(Day(CtoD(vrReplaceText)), 2), " ", "0"))
                vrStr2 = StrTran(vrStr2, "d", Str(Day(CtoD(vrReplaceText))))
    
            ElseIf vrStr1 = "b" Then 'Boolean
                vrStr3 = SubToken(vrFormat, 3, "|")
                vrStr4 = ""
                If At("!", vrStr3) = 1 Then
                    vrStr4 = "!"
                    vrStr3 = SubStr(vrStr3, 2)
                End If
                    
                If (vrReplaceText = vrStr3 And vrStr4 <> "!") Or (vrReplaceText <> vrStr3 And vrStr4 = "!") Then
                    vrStr2 = SubToken(vrFormat, 1, "|")
                Else
                    vrStr2 = SubToken(vrFormat, 2, "|")
                End If
            ElseIf vrStr1 = "i" Then 'Integer
                vrInt1 = Val(vrReplaceText)
                If Right(vrFormat, 1) = "u" Then
                    vrFormat = Left(vrFormat, Len(vrFormat) - 1)
                    vrInt1 = Roundup(vrInt1, 1)
                ElseIf Right(vrFormat, 1) = "d" Then
                    vrFormat = Left(vrFormat, Len(vrFormat) - 1)
                    vrInt1 = Int(vrInt1)
                Else
                    vrInt1 = Round(vrInt1, 1)
                End If
                vrStr2 = Str(vrInt1, Val(vrFormat))
                If (Val(vrFormat) > 0 And Left(vrFormat, 1) = "0") Then
                    vrStr2 = StrTran(vrStr2, " ", "0")
                End If
            End If
            vrReplaceText = vrStr2
            kiDebug vrStr2, ProjectDir & "Debug.log", "VarReplace"
        End If
        
        LogWrite "VarReplace: " + vrReplaceNode + " => " + vrReplaceText, 2, "VarReplace"
        
        vrResultText = StrTran(vrResultText, vrReplaceNode, vrReplaceText)
    Loop
    
    vrMode = ""
    vrCsX = ""
    vrTagName = ""
    vrTagOpen = ""
    vrTagClose = ""
    
    VarReplace = vrResultText
End Function

Function VarReplace_Custom(ByVal vrName As String, ByVal kdvSource As KiDataView) As String
    Dim tmpStr1 As String, tmpStr2 As String, tmpStr3 As String, tmpstr4 As String
    Dim vrReturn As String
    
    vrReturn = ""
    If vrName = "TRACK_LINK" Then
    Else
    End If
    
    VarReplace_Custom = vrReturn
End Function

Sub LogWrite(ByVal sLogText As String, Optional ByVal iLogLevel As Integer = 999, Optional ByVal sSource As String = "")
    kiDebug sLogText, ProjectDir & "debug.log", sSource
End Sub

Function ReadEntireFile(ByVal sFileName)
    Dim iFileNum As Integer
    Dim sFileText As String
    sFileText = ""
    
    If fExist(sFileName) Then
        iFileNum = FreeFile
        Open sFileName For Input As #iFileNum
        sFileText = Input$(LOF(iFileNum), iFileNum)
        Close #iFileNum
    End If
    
    ReadEntireFile = sFileText
End Function

Sub UpdateRightScreen(CS As Object)
    With CS
        .RightTop "Ship to:"
        .RightMiddle ""
        
        
        For commInt(1) = 1 To 7
            commStr(1) = .GetVar("xSHIPTO" & commInt(1))
            If Not KiEmpty(commStr(1)) Then .RightMiddle commStr(1)
        Next
        commStr(1) = .GetVar("xZIP")
        .RightBottom "ZIP: " & commStr(1)
    End With
End Sub

Function Cipher(ByVal sData As String, Optional ByVal sKey As String = "") As String
    Dim l As Long, i As Long, byIn() As Byte, byOut() As Byte, byKey() As Byte
    Dim bEncOrDec As Boolean
     
    If KiEmpty(sKey) Then sKey = "Comenayeahaa"
     
     'confirm valid string and key input:
    If Len(sData) = 0 Or Len(sKey) = 0 Then Cipher = "Invalid argument(s) used": Exit Function
     
     'check whether running encryption or decryption (flagged by presence of "xxx" at start of sData):
    If Left$(sData, 2) = "{!" And Right$(sData, 2) = "!}" Then
        bEncOrDec = False 'decryption
        sData = Mid$(sData, 3, Len(sData) - 4)
        sData = Base64DecodeString(sData)
    Else
        bEncOrDec = True 'encryption
    End If
     
     'assign strings to byte arrays (unicode)
    byIn = sData
    byOut = sData
    byKey = sKey
    l = LBound(byKey)
    For i = LBound(byIn) To UBound(byIn) - 1 Step 2
        byOut(i) = ((byIn(i) + Not bEncOrDec) Xor byKey(l)) - bEncOrDec 'avoid Chr$(0) by using bEncOrDec flag
        l = l + 2
        If l > UBound(byKey) Then l = LBound(byKey) 'ensure stay within bounds of Key
    Next i
    Cipher = byOut
    If bEncOrDec Then Cipher = "{!" & Base64EncodeString(Cipher) & "!}"   'add "xxx" onto encrypted text
End Function

Function EncodeBase64(text As String) As String
    Dim arrData() As Byte
    arrData = StrConv(text, vbFromUnicode)
    
    Dim objXML As MSXML2.DOMDocument60
    Dim objNode As MSXML2.IXMLDOMElement
    
    Set objXML = New MSXML2.DOMDocument60
    Set objNode = objXML.createElement("b64")
    
    objNode.DataType = "bin.base64"
    objNode.nodeTypedValue = arrData
    EncodeBase64 = objNode.text
    
    Set objNode = Nothing
    Set objXML = Nothing
End Function
Function DecodeBase64(text As String) As String
    Dim arrData() As Byte
    arrData = StrConv(text, vbFromUnicode)
    
    Dim objXML As MSXML2.DOMDocument60
    Dim objNode As MSXML2.IXMLDOMElement
    
    Set objXML = New MSXML2.DOMDocument60
    Set objNode = objXML.createElement("b64")
    
    objNode.DataType = "bin.base64"
    objNode.nodeValue = arrData
    DecodeBase64 = objNode.nodeTypedValue
    
    Set objNode = Nothing
    Set objXML = Nothing
End Function

' A Base64 Encoder/Decoder.
'
' This module is used to encode and decode data in Base64 format as described in RFC 1521.
'
' Home page: www.source-code.biz.
' Copyright 2007: Christian d'Heureuse, Inventec Informatik AG, Switzerland.
'
' This module is multi-licensed and may be used under the terms
' of any of the following licenses:
'
'  EPL, Eclipse Public License, V1.0 or later, http://www.eclipse.org/legal
'  LGPL, GNU Lesser General Public License, V2.1 or later, http://www.gnu.org/licenses/lgpl.html
'  GPL, GNU General Public License, V2 or later, http://www.gnu.org/licenses/gpl.html
'  AGPL, GNU Affero General Public License V3 or later, http://www.gnu.org/licenses/agpl.html
'  AL, Apache License, V2.0 or later, http://www.apache.org/licenses
'  BSD, BSD License, http://www.opensource.org/licenses/bsd-license.php
'  MIT, MIT License, http://www.opensource.org/licenses/MIT
'
' Please contact the author if you need another license.
' This module is provided "as is", without warranties of any kind.


' Encodes a string into Base64 format.
' No blanks or line breaks are inserted.
' Parameters:
'   S         a String to be encoded.
' Returns:    a String with the Base64 encoded data.
Public Function Base64EncodeString(ByVal s As String) As String
   Base64EncodeString = Base64Encode(ConvertStringToBytes(s))
End Function

' Encodes a byte array into Base64 format.
' No blanks or line breaks are inserted.
' Parameters:
'   InData    an array containing the data bytes to be encoded.
' Returns:    a string with the Base64 encoded data.
Public Function Base64Encode(InData() As Byte)
   Base64Encode = Base64Encode2(InData, UBound(InData) - LBound(InData) + 1)
End Function

' Encodes a byte array into Base64 format.
' No blanks or line breaks are inserted.
' Parameters:
'   InData    an array containing the data bytes to be encoded.
'   InLen     number of bytes to process in InData.
' Returns:    a string with the Base64 encoded data.
Public Function Base64Encode2(InData() As Byte, ByVal InLen As Long) As String
   If Not InitDone Then Base64Init
   If InLen = 0 Then Base64Encode2 = "": Exit Function
   Dim ODataLen As Long: ODataLen = (InLen * 4 + 2) \ 3     ' output length without padding
   Dim OLen As Long: OLen = ((InLen + 2) \ 3) * 4           ' output length including padding
   Dim Out() As Byte
   ReDim Out(0 To OLen - 1) As Byte
   Dim ip0 As Long: ip0 = LBound(InData)
   Dim ip As Long
   Dim op As Long
   Do While ip < InLen
      Dim i0 As Byte: i0 = InData(ip0 + ip): ip = ip + 1
      Dim i1 As Byte: If ip < InLen Then i1 = InData(ip0 + ip): ip = ip + 1 Else i1 = 0
      Dim i2 As Byte: If ip < InLen Then i2 = InData(ip0 + ip): ip = ip + 1 Else i2 = 0
      Dim o0 As Byte: o0 = i0 \ 4
      Dim o1 As Byte: o1 = ((i0 And 3) * &H10) Or (i1 \ &H10)
      Dim o2 As Byte: o2 = ((i1 And &HF) * 4) Or (i2 \ &H40)
      Dim o3 As Byte: o3 = i2 And &H3F
      Out(op) = Map1(o0): op = op + 1
      Out(op) = Map1(o1): op = op + 1
      Out(op) = IIf(op < ODataLen, Map1(o2), Asc("=")): op = op + 1
      Out(op) = IIf(op < ODataLen, Map1(o3), Asc("=")): op = op + 1
      Loop
   Base64Encode2 = ConvertBytesToString(Out)
End Function

' Decodes a string from Base64 format.
' Parameters:
'    s        a Base64 String to be decoded.
' Returns     a String containing the decoded data.
Public Function Base64DecodeString(ByVal s As String) As String
   If s = "" Then Base64DecodeString = "": Exit Function
   Base64DecodeString = ConvertBytesToString(Base64Decode(s))
End Function

' Decodes a byte array from Base64 format.
' Parameters
'   s         a Base64 String to be decoded.
' Returns:    an array containing the decoded data bytes.
Public Function Base64Decode(ByVal s As String) As Byte()
   If Not InitDone Then Base64Init
   Dim IBuf() As Byte: IBuf = ConvertStringToBytes(s)
   Dim ILen As Long: ILen = UBound(IBuf) + 1
   If ILen Mod 4 <> 0 Then Err.Raise vbObjectError, , "Length of Base64 encoded input string is not a multiple of 4."
   Do While ILen > 0
      If IBuf(ILen - 1) <> Asc("=") Then Exit Do
      ILen = ILen - 1
      Loop
   Dim OLen As Long: OLen = (ILen * 3) \ 4
   Dim Out() As Byte
   ReDim Out(0 To OLen - 1) As Byte
   Dim ip As Long
   Dim op As Long
   Do While ip < ILen
      Dim i0 As Byte: i0 = IBuf(ip): ip = ip + 1
      Dim i1 As Byte: i1 = IBuf(ip): ip = ip + 1
      Dim i2 As Byte: If ip < ILen Then i2 = IBuf(ip): ip = ip + 1 Else i2 = Asc("A")
      Dim i3 As Byte: If ip < ILen Then i3 = IBuf(ip): ip = ip + 1 Else i3 = Asc("A")
      If i0 > 127 Or i1 > 127 Or i2 > 127 Or i3 > 127 Then _
         Err.Raise vbObjectError, , "Illegal character in Base64 encoded data."
      Dim b0 As Byte: b0 = Map2(i0)
      Dim b1 As Byte: b1 = Map2(i1)
      Dim b2 As Byte: b2 = Map2(i2)
      Dim b3 As Byte: b3 = Map2(i3)
      If b0 > 63 Or b1 > 63 Or b2 > 63 Or b3 > 63 Then _
         Err.Raise vbObjectError, , "Illegal character in Base64 encoded data."
      Dim o0 As Byte: o0 = (b0 * 4) Or (b1 \ &H10)
      Dim o1 As Byte: o1 = ((b1 And &HF) * &H10) Or (b2 \ 4)
      Dim o2 As Byte: o2 = ((b2 And 3) * &H40) Or b3
      Out(op) = o0: op = op + 1
      If op < OLen Then Out(op) = o1: op = op + 1
      If op < OLen Then Out(op) = o2: op = op + 1
      Loop
   Base64Decode = Out
End Function

Private Sub Base64Init()
   Dim c As Integer, i As Integer
   ' set Map1
   i = 0
   For c = Asc("A") To Asc("Z"): Map1(i) = c: i = i + 1: Next
   For c = Asc("a") To Asc("z"): Map1(i) = c: i = i + 1: Next
   For c = Asc("0") To Asc("9"): Map1(i) = c: i = i + 1: Next
   Map1(i) = Asc("+"): i = i + 1
   Map1(i) = Asc("/"): i = i + 1
   ' set Map2
   For i = 0 To 127: Map2(i) = 255: Next
   For i = 0 To 63: Map2(Map1(i)) = i: Next
   InitDone = True
End Sub

Private Function ConvertStringToBytes(ByVal s As String) As Byte()
   Dim b1() As Byte: b1 = s
   Dim l As Long: l = (UBound(b1) + 1) \ 2
   If l = 0 Then ConvertStringToBytes = b1: Exit Function
   Dim b2() As Byte
   ReDim b2(0 To l - 1) As Byte
   Dim p As Long
   For p = 0 To l - 1
      Dim c As Long: c = b1(2 * p) + 256 * CLng(b1(2 * p + 1))
      If c >= 256 Then c = Asc("?")
      b2(p) = c
      Next
   ConvertStringToBytes = b2
End Function

Private Function ConvertBytesToString(b() As Byte) As String
   Dim l As Long: l = UBound(b) - LBound(b) + 1
   Dim b2() As Byte
   ReDim b2(0 To (2 * l) - 1) As Byte
   Dim p0 As Long: p0 = LBound(b)
   Dim p As Long
   For p = 0 To l - 1: b2(2 * p) = b(p0 + p): Next
   Dim s As String: s = b2
   ConvertBytesToString = s
End Function

Public Function GetLength(ByVal dblDim1 As Double, ByVal dblDim2 As Double, ByVal dblDim3 As Double) As Double
    GetLength = Roundup(Max(dblDim1, Max(dblDim2, dblDim3)), 1)
End Function
Public Function GetGirth(ByVal dblDim1 As Double, ByVal dblDim2 As Double, ByVal dblDim3 As Double) As Double
    If (dblDim1 > dblDim2) Then
        dblDim1 = dblDim2
        dblDim2 = dblDim3
        dblDim3 = 99999
    End If
    If (dblDim2 > dblDim3) Then
        dblDim2 = dblDim3
        dblDim3 = 99999
    End If
    
    GetGirth = (Roundup(dblDim1, 1) + Roundup(dblDim2, 1)) * 2
End Function
Public Function GetLengthPlusGirth(ByVal dblDim1 As Double, ByVal dblDim2 As Double, ByVal dblDim3 As Double) As Double
    Dim dblLength As Double
    Dim dblGirth As Double
    
    GetLengthPlusGirth = GetLength(dblDim1, dblDim2, dblDim3)
    GetLengthPlusGirth = GetLengthPlusGirth + GetGirth(dblDim1, dblDim2, dblDim3)
End Function

Public Function IsLTL(ByVal sIntcode As String) As Boolean
    IsLTL = False
    
    IsLTL = IsLTL Or At(";" & sIntcode & ";", Common.BolServices) > 0
    IsLTL = IsLTL Or At(";" & Left(sIntcode, 2) & ";", Common.BolServices) > 0
    IsLTL = IsLTL Or At(";" & Left(sIntcode, 1) & ";", Common.BolServices) > 0
End Function





