VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TxDbRef"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'================================================================================
'            * * * * * WARNING * * * * *
'
'Do not modify routines in this Module.
'It is provided by the Tx Converter to support TracerX Functions and mechanisms
'not directly available in VBA
'================================================================================
'
Option Explicit

Private pFilename As String
Private pFields As KiDataView
Private pIndexes() As Long
Private pInitialised As Boolean
Private pFieldCount As Long

Public Function Init(ByVal Filename As String, Optional ByVal CreateVars As Boolean = False, Optional ByVal Prefix As String = "X") As Boolean
Dim zindex As Long

    Set pFields = DbfVarDeclare(Filename)
    If pFields Is Nothing Then
        pFilename = ""
        pInitialised = False
    Else
        pFilename = Filename
        pFieldCount = pFields.Fields.Count
        ReDim pIndexes(1 To pFieldCount)
        For zindex = 1 To pFieldCount
            pIndexes(zindex) = txFieldIndex(Prefix & pFields(zindex - 1).Name, CreateVars)
            Select Case pFields(zindex - 1).DataType
            Case KiType_String
                pFields(zindex - 1).value = Space(pFields(zindex - 1).MaxLength)
            Case KiType_Date
                pFields(zindex - 1).value = CDate(0)
            End Select
        Next zindex
        pInitialised = True
    End If
    Init = pInitialised
End Function

Public Property Get Filename() As String
    Filename = pFilename
End Property

Public Property Get FieldCount() As Long
    FieldCount = pFieldCount
End Property

Public Property Get FieldIndex(ByVal Index As Long) As Long
    If Index > 0 And Index <= pFieldCount Then
        FieldIndex = pIndexes(Index)
    End If
End Property

'Public Property Get Fieldname(ByVal Index As Long) As Long
'    If Index > 0 And Index <= pFieldCount Then
'        Fieldname = pFields(Index - 1).Name
'    End If
'End Property

Public Property Get ResetValue(ByVal Index As Long) As Variant
    If Index > 0 And Index <= pFieldCount Then
        ResetValue = pFields(Index - 1).value
    End If
End Property

Public Function ResetVars() As Boolean
Dim zindex As Long
Dim zVarIndex As Long
        
    For zindex = 1 To pFieldCount
        zVarIndex = FieldIndex(zindex)
        If zVarIndex > 0 Then
            TxVars(zVarIndex) = ResetValue(zindex)
        End If
    Next zindex

End Function

Public Function UpdateVars(Data As KiDataView) As Boolean
    Dim zindex As Long
    Dim zVarIndex As Long
        
    If Not Data Is Nothing Then
        If Data.RowCount Then
            'copy fields to variables
            For zindex = 1 To Data.Fields.Count
                zVarIndex = FieldIndex(zindex)
                If zVarIndex Then
                    TxVars(zVarIndex) = Data(zindex - 1).value
                End If
            Next zindex
            UpdateVars = True
        End If
    End If

End Function

Public Function CopyVars(Data As KiDataView) As Boolean
    Dim zindex As Long
    Dim zVarIndex As Long
        
    If Not Data Is Nothing Then
        If Data.RowCount Then
            'copy fields to variables
            For zindex = 1 To Data.Fields.Count
                zVarIndex = FieldIndex(zindex)
                If zVarIndex Then
                    Data(zindex - 1).value = TxVars(zVarIndex)
                End If
            Next zindex
            CopyVars = True
        End If
    End If

End Function
